﻿@using System.Web.UI.WebControls;


@using Toyota.Common.Web.Html;
@using Toyota.Common.Web.Html.Helper
@using Toyota.Common.Web.MVC;

@using DevExpress.Web.Mvc;
@using DevExpress.Web.Mvc.UI;
@using DevExpress.Utils;
@using Portal.Models.Receiving.KanbanSummaryPartReceiving;


@Html.Common().DevExpress().GridView(
setting =>
{
    setting.Name = "GridKanbanSummaryPartReceiving";
    setting.KeyFieldName = "KANBAN_NO";
    setting.CallbackRouteValues = new { Controller = "KanbanSummaryPartReceiving", Action = "PartialData" };
    //setting.ClientSideEvents.Init = "gridDeliveryInvoice_Init";
    //setting.ClientSideEvents.CustomButtonClick = "func";
    //setting.ClientSideEvents.Init = "grid_init";
    setting.ClientSideEvents.BeginCallback = "OnBeginCallbackGrid";
    //setting.ClientSideEvents.EndCallback = "OnEndCallbackGrid";
    setting.Styles.Header.HorizontalAlign = HorizontalAlign.Center;
    setting.Width = Unit.Percentage(100);
    setting.Settings.HorizontalScrollBarMode = ScrollBarMode.Visible;
    setting.Settings.VerticalScrollBarMode = ScrollBarMode.Hidden;
    setting.Styles.Header.HorizontalAlign = HorizontalAlign.Center;
    setting.Styles.Header.VerticalAlign = VerticalAlign.Middle;
    setting.Settings.ShowFilterRow = true;
    setting.Settings.ShowFilterRowMenu = true;
    setting.SettingsBehavior.AllowSelectSingleRowOnly = false;
    setting.SettingsBehavior.AllowSelectByRowClick = false;
    setting.CommandColumn.ClearFilterButton.Visible = true;
    setting.CommandColumn.ShowSelectCheckbox = true;
    setting.CommandColumn.Visible = false;
    setting.CommandColumn.Width = Unit.Pixel(20);
    setting.SettingsPager.PageSizeItemSettings.Visible = true;
    setting.SettingsPager.PageSizeItemSettings.Items = new string[] { "10", "30", "50", "100" };
    setting.SettingsPager.PageSizeItemSettings.Caption = "Page size";
    setting.Settings.HorizontalScrollBarMode = ScrollBarMode.Visible;
    setting.SettingsPager.FirstPageButton.Visible = true;
    setting.SettingsPager.LastPageButton.Visible = true;
    setting.HtmlDataCellPrepared = (sender, e) =>
    {
        if (e.DataColumn.FieldName == "STATUS")
        {
            //if (e.CellValue.ToString() == "Completed")
            //{
            //    e.Cell.BackColor = System.Drawing.Color.LightGreen;
            //    e.Cell.ForeColor = System.Drawing.Color.Black;
            //}
            //else
            //{
            //    e.Cell.BackColor = System.Drawing.Color.Red;
            //    e.Cell.ForeColor = System.Drawing.Color.Black;
            //}

            switch (e.CellValue.ToString())
            {
                case "Completed":
                    e.Cell.BackColor = System.Drawing.Color.LightGreen;
                    e.Cell.ForeColor = System.Drawing.Color.Black;
                    break;
                case "Ordered":
                    e.Cell.BackColor = System.Drawing.Color.Yellow;
                    e.Cell.ForeColor = System.Drawing.Color.Black;
                    break;
                case "Shortage":
                    e.Cell.BackColor = System.Drawing.Color.Red;
                    e.Cell.ForeColor = System.Drawing.Color.White;
                    break;
                case "Delayed":
                    e.Cell.BackColor = System.Drawing.Color.Red;
                    e.Cell.ForeColor = System.Drawing.Color.White;
                    break;
            }
        }

        if (e.DataColumn.FieldName == "REMARKED")
        {
            if (e.CellValue.ToString() != "0")
            {
                e.Cell.BackColor = System.Drawing.Color.Yellow;
                e.Cell.ForeColor = System.Drawing.Color.Black;
            }
        }
        
        
    };

    setting.CommandColumn.SetHeaderTemplateContent(
    c =>
    {
        Html.DevExpress().CheckBox(
                chckBox =>
                {
                    chckBox.Name = "SelectAllCheckBox";
                    //chckBox.Width = 16;
                    //chckBox.Properties.ClientSideEvents.CheckedChanged = "function(s, e){ GridServiceAcceptance.SelectAllRowsOnPage(chkAllRecord.GetChecked());}";
                    //chckBox.Properties.ClientSideEvents.CheckedChanged = "CheckChange";
                    //chckBox.Checked = c.Grid.Selection.Count > 1;
                    chckBox.Properties.ClientSideEvents.CheckedChanged = string.Format("function(s, e) {{ if(s.GetChecked()) {0}.SelectRows(); else {0}.UnselectRows(); }}", setting.Name);
                    chckBox.Checked = c.Grid.Selection.Count == c.Grid.VisibleRowCount;
                }
            ).Render();
    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "KANBAN_ID";
        col.Caption = "Kanban ID";
        col.Width = 110;
        col.Visible = false;
        col.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
        col.SetDataItemTemplateContent(container =>
        {
            Html.DevExpress().HyperLink(hlSettings =>
            {
                hlSettings.Name = string.Format("hlpr_{0}", (container as GridViewDataItemTemplateContainer).VisibleIndex);
                hlSettings.NavigateUrl = "javascript:void(0)";
                hlSettings.Properties.ClientSideEvents.Click = string.Format("function(s, e) {{ OpenPrint('{0}', '{1}', '{2}'); }}", (container as GridViewDataItemTemplateContainer).Text, DataBinder.Eval(container.DataItem, "ORDER_NO"), DataBinder.Eval(container.DataItem, "PART_NO"));
                hlSettings.Properties.Text = (container as GridViewDataItemTemplateContainer).Text;
            }).Render();
        });
    });


    setting.Columns.Add(col =>
    {
        col.FieldName = "KANBAN_NO";
        col.Caption = "Kanban No";
        col.Width = 50;
        col.FixedStyle = GridViewColumnFixedStyle.Left;
        col.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
        col.SetDataItemTemplateContent(container =>
        {
            Html.DevExpress().HyperLink(hlSettings =>
            {
                hlSettings.Name = string.Format("hlpr_{0}", (container as GridViewDataItemTemplateContainer).VisibleIndex);
                hlSettings.NavigateUrl = "javascript:void(0)";
                hlSettings.Properties.ClientSideEvents.Click = string.Format("function(s, e) {{ OpenPrint('{0}', '{1}', '{2}', '{3}', '{4}'); }}", (container as GridViewDataItemTemplateContainer).Text, DataBinder.Eval(container.DataItem, "ORDER_NO"), DataBinder.Eval(container.DataItem, "PART_NO"), DataBinder.Eval(container.DataItem, "KANBAN_ID"), DataBinder.Eval(container.DataItem, "PART_NAME"));
                hlSettings.Properties.Text = (container as GridViewDataItemTemplateContainer).Text;
            }).Render();
        });
    });

 

    setting.Columns.Add(col =>
    {
        col.FieldName = "PART_NAME";
        col.Caption = "Part Name";
        col.Width = Unit.Pixel(400);
        col.FixedStyle = GridViewColumnFixedStyle.Left;
        col.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Left;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });
    setting.Columns.Add(col =>
    {
        col.FieldName = "PART_NO";
        col.Caption = "Part No";
        col.Width = 110;
        col.FixedStyle = GridViewColumnFixedStyle.Left;
        col.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "QTY_PER_CONTAINER";
        col.Caption = "Qty Per Kbn";
        col.Width = 80;
        col.FixedStyle = GridViewColumnFixedStyle.Left;
        //col.Visible = false;
        col.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;

    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "SUPPLIER_CD";
        col.Caption = "Supplier Code";
        col.Width = 90;
        col.FixedStyle = GridViewColumnFixedStyle.Left;
        //col.Visible = false;
        col.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;

    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "SUPPLIER_NAME";
        col.Caption = "Supplier Name";
        col.Width = 350;
        
        col.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Left;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;

    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "ORDER_NO";
        col.Caption = "Order No";
        col.Width = 90;
        col.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;

    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "MANIFEST_NO";
        col.Caption = "Manifest No";
        col.Width = 90;
        col.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;

    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "STATUS";
        col.Caption = "Status";
        col.Width = 70;
        col.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
        col.SetDataItemTemplateContent(container =>
        {
            Html.DevExpress().HyperLink(hlSettings =>
            {
                hlSettings.Name = string.Format("hlprt_{0}", (container as GridViewDataItemTemplateContainer).VisibleIndex);
                hlSettings.NavigateUrl = "javascript:void(0)";
                hlSettings.Properties.ClientSideEvents.Click = string.Format("function(s, e) {{ OpenUrlPart('{0}', '{1}'); }}", DataBinder.Eval(container.DataItem, "MANIFEST_NO"), DataBinder.Eval(container.DataItem, "KANBAN_NO"));
                hlSettings.Properties.Text = (container as GridViewDataItemTemplateContainer).Text;
            }).Render();
        });
    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "RCV_PLANT_CD";
        col.Caption = "Receiving Plant Code";
        col.Width = 127;
        col.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;

    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "DOCK_CD";
        col.Caption = "Dock Code";
        col.Width = 80;
        col.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "P_LANE_SEQ";
        col.Caption = "P Lane No";
        col.Width = 80;
        col.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;

    });

    setting.Columns.AddBand(
    columnBand =>
    {
        columnBand.Caption = "Total Kanban";
        //columnBand.Width = Unit.Percentage(50);
        columnBand.Columns.Add(
            column =>
            {

                column.Caption = "Order";
                column.Name = "ORDER";
                column.FieldName = "ORDER";
                column.Width = 50;
                column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                column.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
            }
            );

        columnBand.Columns.Add(
            column =>
            {
                column.Caption = "Received";
                column.Name = "RECEIVED";
                column.FieldName = "RECEIVED";
                column.Width = 70;
                column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                column.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
            }
            );
    });

    setting.Columns.AddBand(
            columnBand =>
            {
                columnBand.Caption = "Arrival Time";
                columnBand.Name = "ARRIVAL_TIME";
                columnBand.Visible = true;
                columnBand.Columns.Add(
                    column =>
                    {
                        column.Caption = "Plan";
                        column.Name = "ARRIVAL_PLAN_DT";
                        column.FieldName = "ARRIVAL_PLAN_DT";
                        column.ColumnType = MVCxGridViewColumnType.DateEdit;
                        column.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy HH:mm:ss";
                        var dateEditProperties = column.PropertiesEdit as DateEditProperties;
                        dateEditProperties.EditFormat = EditFormat.DateTime;
                        dateEditProperties.EditFormatString = "dd.MM.yyyy HH:mm:ss";
                        dateEditProperties.UseMaskBehavior = true;
                        column.Width = Unit.Pixel(140);
                        column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                        column.Settings.AutoFilterCondition = AutoFilterCondition.Contains;

                    }
                );

                columnBand.Columns.Add(
                    column =>
                    {
                        column.Caption = "Actual";
                        column.Name = "ARRIVAL_ACTUAL_DT";
                        column.FieldName = "ARRIVAL_ACTUAL_DT";
                        column.ColumnType = MVCxGridViewColumnType.DateEdit;
                        column.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy HH:mm:ss";
                        var dateEditProperties = column.PropertiesEdit as DateEditProperties;
                        dateEditProperties.EditFormat = EditFormat.DateTime;
                        dateEditProperties.EditFormatString = "dd.MM.yyyy HH:mm:ss";
                        dateEditProperties.UseMaskBehavior = true;
                        column.Width = Unit.Pixel(140);
                        column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                        column.Settings.AutoFilterCondition = AutoFilterCondition.Contains;

                    }
                );
            }
    );

    setting.Columns.Add(col =>
    {
        col.FieldName = "ROUTE_RATE";
        col.Caption = "Route - Rit";
        col.Width = 80;
        col.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });


    setting.Columns.Add(
    col =>
    {
        col.Settings.ShowFilterRowMenu = DefaultBoolean.False;
        col.Settings.AllowAutoFilter = DefaultBoolean.False;
        col.Caption = "Remark";
        col.FieldName = "REMARKED";
        col.Width = Unit.Pixel(50);
        col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.VerticalAlign = VerticalAlign.Middle;
        col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
        col.SetDataItemTemplateContent(container =>
        {
            ViewContext.Writer.Write(
             "<a href=\"javascript:void(0)\" onClick=\"remark('" + DataBinder.Eval(container.DataItem, "KANBAN_NO") + "','" + DataBinder.Eval(container.DataItem, "MANIFEST_NO") + "','" + DataBinder.Eval(container.DataItem, "ORDER_NO") + "','" + DataBinder.Eval(container.DataItem, "PART_NO") + "')\">"
             );
            Html.DevExpress().Image(
                 img =>
                 {
                     img.Properties.ImageAlign = ImageAlign.Middle;
                     img.ImageUrl = "~/Content/Images/remark.png";
                 }).Render();
            ViewContext.Writer.Write(
                "</a>"
             );
        });
    }
 );

}).Bind(Model.GetModel<KanbanSummaryPartReceivingModel>().KanbanSummaryPartReceivingListData).GetHtml()